/*
@copyright Louis Dionne 2015
Distributed under the Boost Software License, Version 1.0.
(See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)
 */

#include <boost/hana/tuple.hpp>


struct is_even {
    template <typename N>
    constexpr bool operator()(N n) const { return n % 2 == 0; }
};

int main() {
    constexpr auto tuple = boost::hana::make_tuple(
        <%= (1..input_size).map { |n| "#{n}" }.join(', ') %>
    );
    constexpr auto result = boost::hana::count_if(tuple, is_even{});
    (void)result;
}
